'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 20 May 2003 at 2:46:29 am'!
Object subclass: #DlPortableFilePath
	instanceVariableNames: 'currentDir pathComponents drive isRelative isDirectoryPath '
	classVariableNames: 'BadChars '
	poolDictionaries: ''
	category: 'Dandelion-utils'!

!DlDynamicDocument methodsFor: 'private' stamp: 'MU 5/20/2003 00:29'!
fixName: aString
	^DlPortableFilePath fixName: aString! !


!DlAllClassCategoryIndexHtmlDoc methodsFor: 'building contents' stamp: 'MU 5/20/2003 00:45'!
buildMainContents
	| props str tgt nm |
	props := self properties.
	tgt := props subMenuFrameName.
	str := self createBuildStream.
	str p.
	str center.
	str boldWith: props systemTitle.
	str anchorRef: props overviewName, props htmlSuffix target: props mainFrameName with: props overviewTitle.
	str br.
	str anchorRef: props wholeIndexDirectoryName, '/', props wholeIndexName, props htmlSuffix target: props mainFrameName with: props wholeIndexTitle.
	str centerEnd.
	str hr.
	str anchorRef: props allClassIndexName, props htmlSuffix target: tgt with: props allClassIndexTitle.
	str hr.
	str boldWith: props allClassCategoryIndexTitle.
	str p.
	str ul.
	self analysisStorage getClassCategories do:[ :each |
		str li.
		nm := each name.
		str anchorRef: ((self fixName: nm), '/', props classCategorySummaryName, props htmlSuffix) target: tgt with: nm.
	].
	str ulEnd.
	str endEntry.
	self add: str named: #main.
	! !


!DlAllClassIndexHtmlDoc methodsFor: 'building contents' stamp: 'MU 5/20/2003 00:32'!
buildMainContents
	| props str tgt |
	props := self properties.
	tgt := props mainFrameName.
	str := self createBuildStream.
	str boldWith: props allClassIndexTitle.
	str p.
	str ul.
	self analysisStorage getAllClasses do: 
		[:each | 
		| cat | 
		str li.
		cat := each category.
		cat isNil
			ifTrue: 
				[str spanClass: each minorKey.
				str nextPutAll: each name.
				str spanEnd]
			ifFalse: [str
					anchorRef: (self fixName: cat name) , '/' , each name , props htmlSuffix
					class: each minorKey
					target: tgt
					with: each name]].
	str ulEnd.
	str endEntry.
	self add: str named: #main! !


!DlChangeSetClassesHtmlDoc methodsFor: 'private' stamp: 'MU 5/20/2003 00:33'!
writeClassLinks
	| props str |
	props := self properties.
	str := self buildStream.
	self classes do: 
		[:each | | nm catNm |
		str tr.
		str tagClass: props normalName.
		nm := each name.
		catNm := self fixName: each category name.
		str td.
		(each minorKey == #remove or:[each minorKey == #addedThenRemoved])
			ifTrue: 
				[str spanClass: each minorKey.
				str nextPutAll: each name.
				str spanEnd]
			ifFalse: [str
					anchorRef: '../' , catNm , '/' , each name , props htmlSuffix
					class: each minorKey
					target: props mainFrameName
					with: nm].
		str tdEnd.
		str td.
		(each minorKey == #remove or:[each minorKey == #addedThenRemoved])
			ifTrue: [str nextPutAll: props noneTitle]
			ifFalse: [str
					anchorRef: '../' , catNm , '/' , props classCategorySummaryName , props htmlSuffix
					target: props subMenuFrameName
					with: catNm].
		str tdEnd.
		str trEnd].! !


!DlChangeSetMethodsHtmlDoc methodsFor: 'private' stamp: 'MU 5/20/2003 00:33'!
writeMethodLinks
	| tgt props str |
	props := self properties.
	str := self buildStream.
	tgt := props mainFrameName.
	self methods do: 
		[:each | | cCatNm clsNm | 
		cCatNm := self fixName: each klass category name.
		clsNm := each klass name.
		str tr.
		str tagClass: props normalName.
		str td.
		str
			anchorRef: '../' , cCatNm , '/' , clsNm , props htmlSuffix , '#' , each description , ' ' , each name
			class: each minorKey
			target: tgt
			with: each name.
		str tdEnd.
		str td.
		str
			anchorRef: '../' , cCatNm , '/' , clsNm , props htmlSuffix
			target: tgt
			with: clsNm.
		str tdEnd.
		str trEnd].! !


!DlClassHtmlDoc methodsFor: 'private' stamp: 'mu 5/20/2003 02:46'!
writeClassLinkOf: aDlAnalyzableClass 
	| props str targetCls foundCls |
	props := self properties.
	str := self buildStream.
	targetCls := aDlAnalyzableClass.
	foundCls := self analysisStorage getAllClasses detect: [:analyzedCls | analyzedCls = targetCls]
				ifNone: [].
	(foundCls isNil or: [foundCls isResolved not])
		ifTrue: [str nextPutAll: targetCls name]
		ifFalse: [str anchorRef: '../' , (self fixName: foundCls category name) , '/' , foundCls name , props htmlSuffix with: foundCls name].! !


!DlOverviewHtmlDoc methodsFor: 'building contents' stamp: 'MU 5/20/2003 00:43'!
buildAllClassCategoriesSummary
	| str tgt nm props |
	props := self properties.
	tgt := props subMenuFrameName.
	str := self createBuildStream.
	self writeTableBegin.
	str tr.
	str tagClass: props highlightName.
	str th.
	str boldWith: props allClassCategoryIndexTitle.
	str thEnd.
	self analysisStorage getAllClassCategories do:[ :each |
		str tr.
		str tagClass: props normalName.
		str td.
		nm :=  each name.
		str anchorRef: ((self fixName:nm), '/', props classCategorySummaryName, props htmlSuffix) target: tgt with: nm.
		str tdEnd.
		str trEnd.
	].
	str tableEnd.
	str hr.
	str endEntry.
	self add: str named: #allClassCategoriesSummary.
	
	
	! !


!DlPortableFilePath methodsFor: 'accessing' stamp: 'MU 5/20/2003 00:18'!
pathComponents: aCollectionOfString
	
	pathComponents := aCollectionOfString collect: [:each | self privFixName: each].! !

!DlPortableFilePath methodsFor: 'private' stamp: 'MU 5/20/2003 00:26'!
privFixName: aFilename
	^self class fixName: aFilename! !

!DlPortableFilePath methodsFor: 'private' stamp: 'MU 5/20/2003 00:17'!
privMakeNewPathComponents: aCollectionOfPathComponent
	"just a utility method"
	| oComp aComp orgSize argSize newArr |
	oComp :=  self isDirectoryPath 
		ifTrue: [self pathComponents]
		ifFalse: [self pathComponents copyFrom: 1 to: self pathComponents size - 1].
	aComp := aCollectionOfPathComponent collect: [:each | self privFixName: each].
	orgSize := oComp size.
	argSize := aComp size.
	newArr := Array new: orgSize + argSize.
	1 to: orgSize do: [:idx | newArr at: idx put: (oComp at: idx)].
	1 to: argSize do: [:idx | newArr at: idx + orgSize put: (aComp at: idx)].
	^newArr! !


!DlPortableFilePath class methodsFor: 'class initialization' stamp: 'MU 5/20/2003 00:15'!
initialize
	BadChars := #( $: $< $> $| $/ $\ $? $* $") asSet.! !

!DlPortableFilePath class methodsFor: 'utilities' stamp: 'MU 5/20/2003 00:26'!
fixName: aFilename
	| hasBadChars |
	hasBadChars _ aFilename includesAnyOf: BadChars.
	hasBadChars ifFalse:[^aFilename].
	^ aFilename collect:
		[:char | (BadChars includes: char) 
				ifTrue:[$#] 
				ifFalse:[char]]! !


!DlWholeIndexHtmlDoc methodsFor: 'private' stamp: 'mu 5/20/2003 01:59'!
writeAnalyzableDescriptionLink
	| ana str props ref cls |
	ana := self analyzable.
	str := self buildStream.
	props := self properties.
	ana isResolved
		ifTrue: 
			[ref := '..'.
			ana isClassCategory ifTrue: [ref := ref , '/' , (self fixName: ana name) , '/' , props classCategorySummaryName , props htmlSuffix].
			ana isClass ifTrue: [ref := ref , '/' , (self fixName: ana category name) , '/' , ana name , props htmlSuffix].
			ana isClassMember
				ifTrue: 
					[cls := ana klass.
					ref := ref , '/' , (self fixName: cls category name).
					ref := ref , '/' , cls name.
					ref := ref , props htmlSuffix.
					ref := ref , '#' , ana description , ' ' , ana name].
			ana isGlobalRoot ifTrue: [ref := ref , '/' , props overviewName , props htmlSuffix].
			ana isPool ifTrue: [ref := ref , '/' , props poolDirectoryName , '/' , ana name , props htmlSuffix].
			ana isGlobalVariable ifTrue: [ref := ref , '/' , props globalDirectoryName , '/' , props generalIndexName , props htmlSuffix , '#' , ana name].
			ana isPoolVariable ifTrue: [ref := ref , '/' , props poolDirectoryName , '/' , ana pool name , props htmlSuffix , '#' , ana name].
			str anchorRef: ref with: ana name]
		ifFalse: [props outputResolvedOnly ifFalse: [str boldWith: ana name]].! !

DlPortableFilePath initialize!
